from Config import globals
from Util.util import readFileIntoString 
from Util.util import prettyDFMode
from Config.settings import GLOBAL_XML
from Component import GenericComponent

class OverviewSettings(GenericComponent):
    def display(self):
        glob = globals.CONFIG_SETTINGS.find('GLOBAL')
        
        print "\nInstrument Settings"
        self.displayOnly("Data-Flow Mode", prettyDFMode(glob.EXECUTIONMODE['VALUE']))
        self.displayOnly("FDSN Network Name", glob.NTW['NAME'], [1,3,4,5,6])
        self.displayOnly("FDSN Network Description", glob.NTW['DESC'], [1,3,4,5,6])
        self.displayOnly("FDSN Station Name", glob.STN['NAME'], [1,3,4,5,6])
        self.displayOnly("FDSN Station Description", glob.STN['DESC'], [1,3,4,5,6])
        self.displayOnly("FDSN Location Name", glob.LOC['NAME'], [1,3,4,5,6])
        self.displayOnly("FDSN Location Description", glob.NTW['DESC'], [1,3,4,5,6])
        self.displayOnly("Seismometer Sample Rate", glob.SPSV['VALUE'], [1,3,4,5,6])
        self.displayOnly("Acceleromter Sample Rate", glob.SPSA['VALUE'], [1,3,4,5,6])
 
        seed = globals.CONFIG_SETTINGS.find('SEEDLINK')
        caps = globals.CONFIG_SETTINGS.find('CAPS')
        
        if self.determineDisplay([1,3,4,5]):
            print "\nSeedlink"
            self.displayOnly("Port Number", seed.SCPORT['VALUE'])

        if self.determineDisplay([6]):
            print "\nCAPS"
            self.displayOnly("Port Number", caps.PORT['VALUE'])

        trigger = globals.CONFIG_SETTINGS.find('TRIGGER')

        if self.determineDisplay([1,3,4,5]):
            print "\nEvent Trigger"
            self.displayOnly("Event Triggers (ON|OFF)", trigger.ONOFF['VALUE'])

        #slarchive = globals.CONFIG_SETTINGS.find('SLARCHIVE')

        darien = globals.CONFIG_SETTINGS.find('DARIEN')

        if self.determineDisplay([2]):
            print "\nOSOP Darien Server"
            self.displayOnly("Darien Server Executes (ON|OFF)", darien.ONOFF['VALUE'])

        vtun = globals.CONFIG_SETTINGS.find('VTUN')
        if self.determineDisplay([1]):
            print "\nTunneling"
            self.displayOnly("Tunneling (ON|OFF)", vtun.ONOFF['VALUE'])

    def __init__(self, firstTime):
        self.maxAlignment = 28
        GenericComponent.__init__(self, firstTime)
