import subprocess
import lxml
import re
import os
from settings import SC_MODIFICATIONS, SC_CONFIGURATION, READ_EXECUTABLE, WRITE_EXECUTABLE, RESTART_EXECUTABLE, \
    SC_STATUS, DEFAULTS_FILE, WIZARD
from Util.util import readFileIntoString, writeFile, checkFirstTime, getDebugValue
from bs4 import BeautifulSoup


def init(firstTime):
    callExec(READ_EXECUTABLE)
    # needs to run the ReadConfigSettings Command
    status = readFileIntoString(SC_STATUS)
    status = BeautifulSoup(status, ['lxml', 'xml'])

    global STATUS
    STATUS = status

    config = readFileIntoString(SC_CONFIGURATION)
    config = BeautifulSoup(config, ['lxml', 'xml'])

    global CONFIG_SETTINGS
    CONFIG_SETTINGS = config

    # get the execution mode i.e. Data-Flow Mode
    # iff we're no in wizardMode
    global EXEC_MODE

    if firstTime is not True:
        glob = CONFIG_SETTINGS.find('GLOBAL')
        EXEC_MODE = getExecMode(glob.EXECUTIONMODE['VALUE'])


def callExec(executable):
    """ 
    Decide whether or not to print debug messages to
    stdout
    """
    debug = getDebugValue()

    if debug is True:
        subprocess.call([executable])
    else:
        FNULL = open(os.devnull, 'w')
        subprocess.call([executable], stdout=FNULL, stderr=subprocess.STDOUT)


def write():
    # Writes out all the changes to the settings as store in the globals
    xml = CONFIG_SETTINGS.prettify()
    xml = re.sub("/(<.[^(><.)]+>)/", lambda match: match.group(1).upper(), xml)
    writeFile(SC_MODIFICATIONS, xml)
    # Also call the backend program

    callExec(WRITE_EXECUTABLE)


def shutdown():
    callExec(RESTART_EXECUTABLE)


def getExecMode(value):
    table = {
        'seedlink': 1,
        'darien': 2,
        'data_logger': 3,
        'event_logger': 4,
        'seedlink_local_backup': 5,
        'caps': 6,
        '': 0
    }

    return table[value.lower()]
