from Config.settings import TMP_WIZARD
import os.path

# Read a file
# strip whitespace
# print contents
def displayFile(filename):
    with open(filename) as f:
        lines = f.read().splitlines()
        lines = filter(None, lines)

        for line in lines:
            print line


def fileExists(filename):
    """
    Return True if filename exists

    Arg1 -> string

    """
    return os.path.isfile(filename)

def removeFile(filename):
    """
    Remove file filename
    """
    if fileExists(filename):
        os.remove(filename)

def readFile(filename):
    with open(filename) as f:
        lines = f.read().splitlines()
        lines = filter(None, lines)

        return lines

def writeFile(filename, vals):
    f = open(filename, "wb")
    f.write(vals)
    f.close()


def readFileIntoString(filename):
    with open (filename, "r") as myfile:
        data = myfile.read()
        return data

def checkFirstTime(defaults, wizard):
    """
    Check for the wizard.run file. If it exists
    create a temp file to maintain wizard until
    done to keep wizard mode alive
    """
    lines = readFile(defaults)
    res = None
    for line in filter(lambda x: wizard in x, lines):
        res = line

    res = res.split("=")[1].translate(None, "\"")
    
    if os.path.isfile(res):
        open(TMP_WIZARD, 'a').close()
        return True
    elif os.path.isfile(TMP_WIZARD):
        return True
    else:
        return False

def removeTmpWizard():
    print "Wizard complete. Restarting..."
    os.remove(TMP_WIZARD)


def prettyDFMode(val):
    # used to make the output pretty for users
    pretty_table = {
            "SEEDLINK": "SeedLink Streamer",
            "DARIEN": "Darien Client",
            "DATA_LOGGER": "Data Logger",
            "EVENT_LOGGER": "Event Logger",
            "SEEDLINK_LOCAL_BACKUP": "SeedLink Streamer (With Local Backup)",
            "CAPS": "CAPS",
            "": ""
    }

    return pretty_table[val]


DEBUG = False

def getDebugValue():
    return DEBUG

def setDebugValueTrue():
    global DEBUG
    DEBUG = True

