<?php
include 'paths.php';
//ini_set('display_errors', 'On');
//ini_set('display_errors',1);
//ini_set('display_startup_errors',1);
//error_reporting(-1);


function findSixVersion(){
    $verFile = file("/opt/settings/sc-xml/FW-ver.txt");
    $version = $verFile[0];
    echo "Version ". $version[0];
    return $version[0];
}

function getArchiveDays(){
    $ver = findSixVersion();
    if($ver == '3') {
        return '3';
    } elseif ($ver == '4') {
        return '7';
    } else {
        return '3';
    }
}


/*Is an active user*/
function isAtiveUser() {
    session_start();
    if(!isset($_SESSION['user'])) {
        return false;
    }
    return true;
}

/*Read the XML created for PHP App*/
function readXML() {
    /*
    * Generate the settings so we can use them
    */
    shell_exec(readsixaolasettings);
    $xml = simplexml_load_file(xmlConfiguration);

    if(!isset($_SESSION['EXECMODE']) || empty($_SESSION['EXECMODE'])) {
        $_SESSION['EXECMODE'] = (string)$xml->GLOBAL->EXECUTIONMODE->attributes()->VALUE;
        updateCurrentMode($_SESSION['EXECMODE']);
    }

    return $xml;
}


/*
* Write and XML depending on if it has the data on session adds from there,
* in other case, create the file
*/
function writeXML() {
    if(isset($_SESSION['xml'])){
        $xml = new SimpleXMLElement($_SESSION['xml']);
    } else {
        $xml = new SimpleXMLElement( "<SIXAOLA></SIXAOLA>" );
    }
    $f = @fopen(xmlModifications , "W");
    if ($f !== false) {
        ftruncate($f, 0);
        fclose($f);
    }
    $xml->asXML(xmlModifications);
    shell_exec(sixaolarestart);
}

/*
* Create the XML structure and execute the changes
* All XML must follow convetion
* {parent}_{node-name}_{attribute-name}
*/
function createXML($data) {
    if(isset($_SESSION['xml'])){
        $xml = new SimpleXMLElement($_SESSION['xml']);
    } else {
        $xml = new SimpleXMLElement( "<SIXAOLA></SIXAOLA>" );
    }
    foreach ($data as $key => $value) {
        if($key != 'undefined'){
            if($key == 'WEB_PASSWORD') {
                changePass($value);
            } elseif($key == "WEB_USER") {
                changeUser($value);
            } else {
                $keys = explode("_", $key);
                $node = $keys[0];
                $key1 = $keys[1];
                $key2 = $keys[2];
                $xml->{$node}->{$key1}[$key2] = $value;
            }
        }
    }
    $xml->asXML (xmlModifications);
    $_SESSION['xml'] = $xml->asXML();

    shell_exec(savesixaolasettings);
}

/* Change the user password */
function changePass($newPass) {
    $reading = fopen(txtUser, 'r');
    $writing = fopen(txtTmpUser, 'w');
    $replaced = false;
    while (!feof($reading)) {
        $line = fgets($reading);
        $data = explode("|;_;|", $line);
        $user = $data[0];
        $line = $user. "|;_;|". (sha1(md5(addslashes($newPass))));
        fputs($writing, $line);
    }
    echo "Changing password for " . $user . " to " .  $newPass;

    fclose($reading); fclose($writing);

    rename(txtTmpUser, txtUser);
    unlink(txtTmpUser);
}

function wizardComplete() {
    /*
    * Delete the WIZARD_TMP file, call sixaolarestart
    * and terminate
    */
    unlink(WIZARD_TMP);


    if(isset($_SESSION['xml'])){
        $xml = new SimpleXMLElement($_SESSION['xml']);
    } else {
        $xml = new SimpleXMLElement( "<SIXAOLA></SIXAOLA>" );
    }
    $f = @fopen(xmlModifications , "W");
    if ($f !== false) {
        ftruncate($f, 0);
        fclose($f);
    }
    $xml->asXML (xmlModifications);
    shell_exec(sixaolarestart);
}


/*
* Takes an array of one or more numbers
* used to match the look up mode, if
* any of the numbers are in the table
* then this function will return true.
* It is used to determine whether or not
* we should show a field as greyed out
* @param Array of Numbers representing modes
*        in the table
*/
function requiresModesToShow(array $modes) {
    //print("CurrentMode " . $_SESSION['currentMode']);
    //var_dump($_SESSION['currentMode']);
    //print("modes available: " . var_dump($modes) );
    //var_dump($modes);
    return in_array($_SESSION['currentMode'], $modes);
}


/*
* Echo a data atrribute so JS can disable the input easily on the client
* Checks if requires mode to show is true
* if it is -> do nothing
* else -> echo a disabled attribute so this field cannot be edited
*/
function echoDataRequires(array $values) {
    echo "data-requires='" . implode(',', $values) . "'"; //allows easy acces for JavaScript to disable it if necessary
}



/*
* Determines whether or not an
* element should be shown
* depending on the execution mode
*/
function determineHide(array $values) {
    if(requiresModesToShow($values))
    return;
    else
    echo "hide";
}


/*
* Some settings are not available
* in certain modes. This displays
* a message to the user informing
* them of this.
*/
function tellNotAvailable(array $values) {
    if(requiresModesToShow($values))
    return;
    else
    echo "This feature is not available in data-flow mode: <b>" . translateExecMode($_SESSION['EXECMODE']) . "</b>";
}


/*
* Helper to check if item should be visible in Overview Settings
*/
function shouldBeInOverview(array $values, $show = false) {
    if(requiresModesToShow($values) || $show || !isset($show))
    return true;
    else
    return false;
}

/*
* Use a table to translate
* exec modes into more readable
* text
*/
function translateExecMode($mode) {
    $table = array(
        "seedlink" => "SeedLink Streamer",
        "darien" => "Darien Client",
        "data_logger" => "Data Logger",
        "event_logger" => "Event Logger",
        "seedlink_local_backup" => "SeedLink Streamer (With Local Backup)",
        "caps" => "CAPS",
        "" => ""
    );

    return $table[strtolower($mode)];

}

/*
* Change the execMode in the session
*/
function updateExecMode($value) {
    $_SESSION['EXECMODE'] = $value;
    unset($_SESSION['xml']);
    updateCurrentMode($value);

}


/*
* Update the currentMode - used for indexing table
* and determining what to show
*/
function updateCurrentMode($execmode) {
    $_lookUpTable = array(
        '1' => "seedlink",
        '2' => "darien",
        '3' => "data_logger",
        '4' => "event_logger",
        '5' => "seedlink_local_backup",
        '6' => "caps"
    );

    $_SESSION['currentMode'] = array_search(strtolower($execmode), $_lookUpTable);

}

/*
* Read the user from the user.txt file
*/
function readUser() {
    $reading = fopen(txtUser, 'r');
    while(!feof($reading)) {
        $line = fgets($reading);
        $user = substr($line, 0, strpos($line, "|;_;|"));
        return $user;
    }
    fclose($reading);
}

/*
* Change the user
*/
function changeUser($value) {
    $reading = fopen(txtUser, 'r');
    $writing = fopen(txtTmpUser, 'w');
    echo "Changing user..." . $user . PHP_EOL;
    while(!feof($reading)) {
        $line = fgets($reading);
        if(strpos($line, "|;_;|") != -1) {
            $user = substr($line, 0, strpos($line, "|;_;|"));
            //cut the line in half
            $index = strpos($line, "|;_;|");
            $line = substr($line, strpos($line, "|;_;|"), -1);
            $line = $value . $line;
            fputs($writing, $line);
            break;
        }
    }
    fclose($reading); fclose($writing);
    rename(txtTmpUser, txtUser);
    unlink(txtTmpUser);

}

/*
* Get the uptime of the instrument
* using /proc/uptime
*/

function parseTime($x) {
    $x = explode(":", $x);
    $hours = intval($x[0]);
    $minutes = intval($x[1]);

    if($hours > 1) {
        $string = $hours . " hours " . $minutes . " minutes";
    } else if($hours === 1) {
        $string = $hours . " hour " . $minutes . " minutes";
    } else {
        $string = $minutes . " minutes";
    }

    return $string;
}

/*
* Unfortunately the uptime command does not follow a consistent format
* in its output.
*/
function getUptime() {
    $x = exec("uptime");
    if(strpos($x, 'days') !== false || strpos($x, "hrs") || strpos($x, "min") || strpos($x, 'day') !== false) {
        $x = substr($x, 0, strpos($x, "user") - 5);
        $x = substr($x, strpos($x, "up") + 2, strlen($x));


        if(strpos($x, ":") !== false) {
            $x = explode(",", $x);
            return $x[0] . " " . parseTime($x[1]);
        }

        return $x;

    }

    $x = explode(",", $x);
    $x = $x[0];
    $x = substr($x, strpos($x, "up")+3, strlen($x));
    return parseTime($x);
}

/*
* Takes GLOBAL XML tag and works out the
* the station name
*/
function getStationName($xml) {
    $name = $xml->NTW->attributes()->NAME . ".". $xml->STN->attributes()->NAME;
    if($xml->LOC->attributes()->NAME == "--" || NULL)
    return $name;
    else
    return $name . "." . $xml->LOC->attributes()->NAME;
}


/*
* Read the status XML file
*/
function readStatusXML() {
    $xml = simplexml_load_file(STATUS_XML);
    return $xml;
}


/*
* Takes the GLOBALS XML and makes
* a nice pretty channel rate string
*/
function translateSampleRates($xml) {
    $spsvTable = array(
        "100" => "EH",
        "50" => "SH",
        "0" => ""
    );

    $spsaTable = array(
        "200" => "EN",
        "100" => "EN",
        "50" => "SN",
        "0" => ""
    );

    if (empty($spsvTable[(string)$xml->SPSV->attributes()->VALUE]))
        return $spsaTable[(string)$xml->SPSA->attributes()->VALUE];
    else
        if (empty($spsaTable[(string)$xml->SPSA->attributes()->VALUE]))
            return $spsvTable[(string)$xml->SPSV->attributes()->VALUE];
        else
            return $spsvTable[(string)$xml->SPSV->attributes()->VALUE] . ", ".$spsaTable[(string)$xml->SPSA->attributes()->VALUE];


}

/*
* Sends the get GPS coordinate packet to the board.
*/
function queryGPS() {
    //    echo $logFile . PHP_EOL;
    $Cmd = "echo '@' > /dev/ttyO4";
    $handle = shell_exec($Cmd);
}

/*
* Check for the existence of the GPS
* file and turn determine if it is locked or
* unlocked. No file means it is Not Locked
*/
function readGPS($file_loc) {

    if(!file_exists($file_loc)) {
        return translateGPS("OFF");
    }

    $f = fopen($file_loc, 'r');
    $line = fgets($f);
    fclose($f);

    return translateGPS(trim($line));

}
/*
function printCoord2($raw) {
    $exploded = explode(".", $raw);
    $degrees = substr( $exploded[0], 0, -2);
    $degreesInt = sscanf($degrees, "%d")[0];
    $minuteInt = substr( $exploded[0], -2);

    return join(array($degreesInt, '° ', $minuteInt,".", $exploded[1], "'"));
}

function printCoord($raw) {
    $exploded = explode(".", $raw);
    $degrees = substr( $exploded[0], 0, -2);
    $degreesInt = sscanf($degrees, "%d")[0];
    $minuteInt = substr( $exploded[0], -2);
    $secSTR = join(array("0."), $exploded[1]);
    $seconds = sscanf($secSTR, "%f")[0] *60;

    return join(array($degreesInt, '° ', $minuteInt,"' ", $seconds, '"'));
}

function osmLink($strlist) {

    function printForOSM($raw, $dir){
        $exploded = explode(".", $raw);
        $degreeSTR = substr( $exploded[0], 0, -2);
        $minuteInt = substr( $exploded[0], -2);
        $minuteSTR = join(".", array($minuteInt, $exploded[1]));
        $minutes = sscanf( $minuteSTR, "%f");
        $degrees = sscanf( $degreeSTR, "%f");
        $degrees = $degrees[0] + ($minutes[0] / 60);
        $retval = $degrees;
        if ( ($dir == "W") or ($dir == "S"))
            $retval = $degrees * (-1);
        //$retval = join(array($retval, fprintf("%f",$degrees)));
        //echo fprintf("%f",$degrees);
        //echo $degrees;
        return $retval;

    }

    echo "<br>";
    $lat = printForOSM($strlist[0], $strlist[1]);
    $lon = printForOSM($strlist[2], $strlist[3]);

    echo "<a href=http://www.openstreetmap.org/?mlat=$lat&mlon=$lon#map=15/$lat/$lon&layers=N > Link </a>";
}
*/

function osmLink($strlist) {

    echo "<br>";
    $lat = $strlist[0];
    $lon = $strlist[1];

    echo "<a href='http://www.openstreetmap.org/?mlat=$lat&mlon=$lon#map=15/$lat/$lon&layers=N' target='_blank'> Link </a>";
}


/*
* Check for the existence of the GPS
* file and turn determine if it is locked or
* unlocked. No file means it is Not Locked
*/
function checkGPScoords($file_loc) {

//    ini_set('display_errors', 'On');
//    error_reporting(E_ALL);

    $gpsLock = readGPS($file_loc);
    if( $gpsLock != "Locked" ) {
        return;
    }
    $statusXML = readStatusXML();
    $gpsFile = $statusXML->GPSCOORD->attributes()->VALUE;

    if(file_exists($gpsFile)) {

        $lines = file($gpsFile, FILE_IGNORE_NEW_LINES);


        echo  "<tr>";
        echo    "<td><label>GPS coordinates</label></td>  <td> Latitude: $lines[0]<br>Longitude: $lines[1]";

        if ( count($lines) == 3)
            echo "<br> Altitude: $lines[2] m";

        osmLink($lines);
        echo    "</td>      </tr>";

    }

}

/*
* Read Software/Hardware version from file
* If it doesn't exist - no software/hardware version
* Default to 1.0
*/
function readSWHWVersion($file_loc) {


    if(!file_exists($file_loc)) {
        return "1.0";
    }

    $f = fopen($file_loc, 'r');
    $line = fgets($f);
    fclose($f);

    $line = trim($line);

    if(empty($line)) {
        return "1.0";
    }

    return trim($line);
}


/*
* Translate GPS to locked or not Locked
*/
function translateGPS($value) {
    return $value == "ON" ? "Locked" : "Not Locked";
}

/*
* Get MAC Address
*/
function getMacAddress() {
    $address = shell_exec(MAC_ADD_EXECUTABLE);
    return $address;
}


/*
* Get MAC Address
*/
function getIPAddress() {
    $address = shell_exec(IP_ADD_EXECUTABLE);
    if(strstr($address, "\n")) {
        $address = explode("\n", $address);
        return $address[0];
    }

    return $address;
}


/*
* Create the wizard.run file again
* and regenerate the defaults.
* Used when someone goes back so that
* they're previous settings are removed
*/
function regenerateDefaults() {
    session_destroy();
    touch(WIZARD_FILE);
    shell_exec(readsixaolasettings);
}


/*
* Use the script to determine if
* SEEDLINK is running or not.
* In Darien Mode, only check if TRIGGER is ON,
* otherwise just make it empty.
*/
function checkSeedlink($xml) {
    if($xml->GLOBAL->EXECUTIONMODE->attributes()->VALUE == "DARIEN"
    && $xml->TRIGGER->ONOFF->attributes()->VALUE == "OFF") {
        echo "";
    }

    if($xml->GLOBAL->EXECUTIONMODE->attributes()->VALUE == "CAPS") {
        $result = shell_exec(CHECK_CAPS);
        checkLicenseFileCaps();
        if (!strstr($result, "not")){
            echo "<a target='_blank' href='http://" . $_SERVER['HTTP_HOST'] . ":8080'>" . $result . "</a>";
        } else {
            echo $result;
        }
    } else {
        $result = shell_exec(CHECK_SEEDLINK);
        echo $result;
    }
}

/*
*   Check if there is a license file present at /root/.seiscomp3/licenses/caps.crt
*/

function checkLicenseFileCaps(){
    $capsPath = "/root/.seiscomp3/licenses/caps.crt";
    $result = shell_exec("sudo ls $capsPath");
    if (! $result) {
        echo "Warning: no caps.crt license file found.<br>";
        echo "Upload the license file from the 'Premium' tab.<br>";
    }

}


function getTime() {
    //    echo $logFile . PHP_EOL;
    $timeCmd = "date -u";

    //    echo $tailCmd;

    $timeProc = proc_open($timeCmd, array(
        array("pipe","r"), //stdin
        array("pipe","w"), //stdout
        array("pipe","w")  //stderr
    ),
    $pipes);

    $timeOutput = stream_get_contents($pipes[1]);

    //close all streams
    fclose($pipes[0]);
    fclose($pipes[1]);
    fclose($pipes[2]);
    $timeRetVal = proc_close($timeProc);

    return $timeOutput;

}

function mountUSB() {
    $dfCmd = "sudo mkdir /optUSB; sudo mount -v -o rw,noatime /dev/sda1 /optUSB";

    $dfProc = proc_open($dfCmd, array(
                        array("pipe","r"), //stdin
                        array("pipe","w"), //stdout
                        array("pipe","w")  //stderr
                        ),
                       $pipes);

    $dfOutput = stream_get_contents($pipes[1]);
    echo $dfOutput;
     //close all streams
    fclose($pipes[0]);
    fclose($pipes[1]);
    fclose($pipes[2]);
    $dfRetVal = proc_close($dfProc);

}


function archiveLimit($global) {

    mountUSB();

    $SPSV = $global->SPSV->attributes()->VALUE;
    $SPSA = $global->SPSA->attributes()->VALUE;

    //echo "Starting df";
     $dfCmd = "df | grep optUSB";

  $dfProc = proc_open($dfCmd, array(
    array("pipe","r"), //stdin
    array("pipe","w"), //stdout
    array("pipe","w")  //stderr
  ),
                        $pipes);

    $dfOutput = stream_get_contents($pipes[1]);

      //close all streams
  fclose($pipes[0]);
  fclose($pipes[1]);
  fclose($pipes[2]);
  $dfRetVal = proc_close($dfProc);

    //echo $dfOutput;
   $keywords = preg_split("/[\s,]+/", $dfOutput);
   $freeSpace = $keywords[3];


   $bytesPerDay = 331 * ($SPSV + $SPSA); // Empiric test with 5% safety margin.
   return floor($freeSpace / $bytesPerDay);
}

function getDiscUsagePerc(){

    $myfile = fopen("/proc/version", "r");
    $line = fgets($myfile);
    fclose($myfile);
    $Cmd = "";

    if (strpos($line, "Debian") !== false) {
        $Cmd = "df -h | grep mmcblk    | awk '{print $5 \" used, \" $4 \" available\"}'";
    } else {
        $Cmd = "df -h | grep /dev/root | awk '{print $5 \" used, \" $4 \" available\"}'";
    }

  $Proc = proc_open($Cmd, array(
    array("pipe","r"), //stdin
    array("pipe","w"), //stdout
    array("pipe","w")  //stderr
                    ),
                        $pipes);

    $Output = stream_get_contents($pipes[1]);

      //close all streams
      fclose($pipes[0]);
      fclose($pipes[1]);
      fclose($pipes[2]);
      $RetVal = proc_close($Proc);

    echo $Output;
}




?>
